diff --git a/testing/examples/att2/fileC b/testing/examples/att2/fileC
new file mode 100644
index 000000000..2c9a92bfe
--- /dev/null
+++ b/testing/examples/att2/fileC
@@ -0,0 +1 @@
+Text in fileC
\ No newline at end of file
diff --git a/testing/examples/att2/fileD b/testing/examples/att2/fileD
new file mode 100644
index 000000000..c706556c5
--- /dev/null
+++ b/testing/examples/att2/fileD
@@ -0,0 +1 @@
+text in fileD
diff --git a/testing/examples/attachments.org b/testing/examples/attachments.org
new file mode 100644
index 000000000..ab4a4e548
--- /dev/null
+++ b/testing/examples/attachments.org
@@ -0,0 +1,32 @@
+#+TITLE: Org attach testfile
+Used to test and verify the functionality of org-attach.
+
+* H1
+ :PROPERTIES:
+ :DIR:      att1
+ :END:
+A link to one attachment: [[attachment:fileA]]
+
+** H1.1
+A link to another attachment: [[attachment:fileB]]
+
+** H1.2
+  :PROPERTIES:
+  :DIR:      att2
+  :END:
+
+* H2
+ :PROPERTIES:
+ :ID:       abcd123
+ :END:
+
+* H3
+ :PROPERTIES:
+ :DIR:      att1
+ :ID:       abcd1234
+ :END:
+
+** H3.1
+  :PROPERTIES:
+  :ID:       abcd12345
+  :END:
diff --git a/testing/examples/data/ab/cd123/fileE b/testing/examples/data/ab/cd123/fileE
new file mode 100644
index 000000000..80d337772
--- /dev/null
+++ b/testing/examples/data/ab/cd123/fileE
@@ -0,0 +1 @@
+peek-a-boo
diff --git a/testing/lisp/test-org-attach-annex.el b/testing/lisp/test-org-attach-git.el
similarity index 93%
rename from testing/lisp/test-org-attach-annex.el
rename to testing/lisp/test-org-attach-git.el
index 7f2792696..8b826b72f 100644
--- a/testing/lisp/test-org-attach-annex.el
+++ b/testing/lisp/test-org-attach-git.el
@@ -20,19 +20,19 @@
 
 ;;; Code:
 (org-test-for-executable "git-annex")
-(require 'org-attach)
+(require 'org-attach-git)
 (require 'cl-lib)
 
-(defmacro test-org-attach-annex/with-annex (&rest body)
+(defmacro test-org-attach-git/with-annex (&rest body)
   `(let ((tmpdir (make-temp-file "org-annex-test" t "/")))
      (unwind-protect
 	 (let ((default-directory tmpdir)
-	       (org-attach-directory tmpdir))
+	       (org-attach-id-dir tmpdir))
 	   (shell-command "git init")
 	   (shell-command "git annex init")
 	   ,@body))))
 
-(ert-deftest test-org-attach/use-annex ()
+(ert-deftest test-org-attach-git/use-annex ()
   (test-org-attach-annex/with-annex
    (let ((org-attach-git-annex-cutoff 1))
      (should (org-attach-use-annex)))
@@ -44,12 +44,12 @@
   (let ((tmpdir (make-temp-file "org-annex-test" t "/")))
      (unwind-protect
 	 (let ((default-directory tmpdir)
-	       (org-attach-directory tmpdir))
+	       (org-attach-id-dir tmpdir))
 	   (shell-command "git init")
 	   (should-not (org-attach-use-annex)))
        (delete-directory tmpdir 'recursive))))
 
-(ert-deftest test-org-attach/get-maybe ()
+(ert-deftest test-org-attach-git/get-maybe ()
   (test-org-attach-annex/with-annex
    (let ((path (expand-file-name "test-file"))
 	 (annex-dup (make-temp-file "org-annex-test" t "/")))
diff --git a/testing/lisp/test-org-attach.el b/testing/lisp/test-org-attach.el
index c2f2be356..5bcfe86fd 100644
--- a/testing/lisp/test-org-attach.el
+++ b/testing/lisp/test-org-attach.el
@@ -28,6 +28,75 @@
 (require 'org-attach)
 (eval-and-compile (require 'cl-lib))
 
+(ert-deftest test-org-attach/dir ()
+  "Test `org-attach-get' specifications."
+  (should (equal "Text in fileA\n"
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 157) ;; First attachment link
+		   (org-open-at-point)
+		   (buffer-string))))
+  (should-not (equal "Text in fileB\n"
+		     (org-test-in-example-file org-test-attachments-file
+		       (goto-char 219) ;; Second attachment link
+		       (let ((org-attach-use-inheritance nil))
+			 (org-open-at-point)
+			 (buffer-string)))))
+  (should (equal "Text in fileB\n"
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 219) ;; Second attachment link
+		   (let ((org-attach-use-inheritance t))
+		     (org-open-at-point)
+		     (buffer-string)))))
+  (should-not (equal "att1"
+		     (org-test-in-example-file org-test-attachments-file
+		       (goto-char 179) ;; H1.1
+		       (let ((org-attach-use-inheritance nil))
+			 (org-attach-dir)))))
+  (should (equal "att1"
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 179) ;; H1.1
+		   (let ((org-attach-use-inheritance t))
+		     (org-attach-dir)))))
+  (should (equal '("fileC" "fileD")
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 239) ;; H1.2
+		   (org-attach-file-list (org-attach-dir)))))
+  (should (equal '("fileC" "fileD")
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 239) ;; H1.2
+		   (org-attach-file-list (org-attach-dir)))))
+  (should (equal '("fileE")
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 289) ;; H2
+		   (let ((org-attach-id-dir "data/"))
+		     (org-attach-file-list (org-attach-dir))))))
+  (should (equal "peek-a-boo\n"
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 289) ;; H2
+		   (let ((org-attach-id-dir "data/"))
+		     (org-attach-open-in-emacs)
+		     (buffer-string)))))
+  (should (equal  '("fileA" "fileB")
+		  (org-test-in-example-file org-test-attachments-file
+		    (goto-char 336) ;; H3
+		    (org-attach-file-list (org-attach-dir)))))
+  (should (equal "data/ab/cd12345"
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 401) ;; H3.1
+		   (let ((org-attach-use-inheritance nil)
+			 (org-attach-id-dir "data/"))
+		     (file-relative-name (org-attach-dir))))))
+  (should (equal '("fileA" "fileB")
+		 (org-test-in-example-file org-test-attachments-file
+		   (goto-char 401) ;; H3.1
+		   (let ((org-attach-use-inheritance t))
+		     ;; This is where it get's a bit sketchy...! DIR always has
+		     ;; priority over ID, even if ID is declared "higher up" in the
+		     ;; tree.  This can potentially be revised.  But it is also
+		     ;; pretty clean.  DIR is always higher in priority than ID right
+		     ;; now, no matter the depth in the tree.
+		     (org-attach-file-list (org-attach-dir)))))))
+
 (ert-deftest test-org-attach/dired-attach-to-next-best-subtree/1 ()
   "Attach file at point in dired to subtree."
   (should
diff --git a/testing/lisp/test-org.el b/testing/lisp/test-org.el
index d671b5c78..a618da479 100644
--- a/testing/lisp/test-org.el
+++ b/testing/lisp/test-org.el
@@ -2514,7 +2514,11 @@ Foo Bar
      (catch :result
        (cl-letf (((symbol-function 'org-tags-view)
 		  (lambda (&rest args) (throw :result t))))
-	 (org-open-at-point)
+	 ;; When point isn't on a tag it's going to try other things,
+	 ;; possibly trying to open attachments which will return an
+	 ;; error if there isn't an attachment. Supress that error.
+	 (ignore-errors
+	     (org-open-at-point))
 	 nil)))))
 
 
diff --git a/testing/org-test.el b/testing/org-test.el
index 295df1919..c3e21eb30 100644
--- a/testing/org-test.el
+++ b/testing/org-test.el
@@ -87,6 +87,9 @@ org-test searches this directory up the directory tree.")
 (defconst org-test-no-heading-file
   (expand-file-name "no-heading.org" org-test-example-dir))
 
+(defconst org-test-attachments-file
+  (expand-file-name "attachments.org" org-test-example-dir))
+
 (defconst org-test-link-in-heading-file
   (expand-file-name "link-in-heading.org" org-test-dir))
 
-- 
2.17.1

